/////////////////////////////////////////////////////////////////////
// Class Creator Version 2.0.000 Copyrigth (C) Poul A. Costinsky 1994
///////////////////////////////////////////////////////////////////
// Header File btmatrix.h
// class CWizBitMatrix
//
// 31/05/1995 12:24                             Author: Poul
///////////////////////////////////////////////////////////////////

#ifndef __CWizBitMatrix_H
#define __CWizBitMatrix_H
/////////////////////////////////////////////////////////////////////////////
// class CWizBitVectorValue
class CWizBitVectorValue
{
public:
// Constructor
	CWizBitVectorValue(DWORD& rValue, int nBit)
		: m_rValue (rValue) , m_nBit(nBit) { }
public:
// Operations
	void operator=(BOOL bValue)
		{
		if (bValue) m_rValue |= DWORD(1) << m_nBit;
		else	    m_rValue &= ~(DWORD(1) << m_nBit);
		}
protected:
// Members:
	DWORD	m_rValue;
	int	m_nBit;
};
/////////////////////////////////////////////////////////////////////////////
// class CWizBitVector
template <int BIT_MATRIX_COLS>
class CWizConstBitVector
{
public:
enum	{ 
	BITS_IN_WORD = 32, 
	WORDS_IN_LINE = (BIT_MATRIX_COLS + BITS_IN_WORD -1)/BITS_IN_WORD,
	};
// Constructor
	CWizConstBitVector(const DWORD *pData) : m_pData((DWORD *)pData) { }
public:
// Operations
	BOOL operator[](int i) const 
		{
		return Check(i);
		}
protected:
// Implementation:
	static int	Index(int i) { return i/BITS_IN_WORD;}
	static int	Bit  (int i) { return i%BITS_IN_WORD;}
	static DWORD	Mask (int i) { return (DWORD(1) << (i%BITS_IN_WORD));}
	
	DWORD&   	Data  (int i) const { return m_pData [i/BITS_IN_WORD];}
	const int Check (int i) const
		{
		return ((Data(i) & Mask(i)) ? 1 : 0);
		}
// Members:
	DWORD	*m_pData;
};
/////////////////////////////////////////////////////////////////////////////
// class CWizBitVector
template <int BIT_MATRIX_COLS>
class CWizBitVector : public CWizConstBitVector<BIT_MATRIX_COLS>
{
public:
// Constructor
	CWizBitVector(DWORD *pData) 
		: CWizConstBitVector<BIT_MATRIX_COLS>(pData) { }
public:
// Operations
	BOOL operator[](int i) const 
		{
		return Check(i);
		}
	CWizBitVectorValue operator[](int i)
		{
		return CWizBitVectorValue (Data(i),Bit(i));
		}
	void Set(int i, BOOL bValue)
		{
		if (bValue) Data(i) |= Mask(i);
		else	    Data(i) &= ~(Mask(i));
		}
	CWizBitVector& operator=(const CWizBitVector& T)
		{
		memcpy (m_pData, T.m_pData, WORDS_IN_LINE*sizeof(DWORD));
		return *this;
		}
	CWizBitVector& operator=(BOOL b)
		{
		char ch = (b) ? 0xFF : 0;
		memset (m_pData, ch, WORDS_IN_LINE*sizeof(DWORD));
		return *this;
		}
protected:
// Members:
};
/////////////////////////////////////////////////////////////////////////////
// class CWizBitMatrix
template <int BIT_MATRIX_ROWS, int BIT_MATRIX_COLS>
class CWizBitMatrix
{
enum	{ 
	BITS_IN_WORD = CWizConstBitVector<BIT_MATRIX_COLS>::BITS_IN_WORD, 
	WORDS_IN_LINE = CWizConstBitVector<BIT_MATRIX_COLS>::WORDS_IN_LINE,
	};
public:
// Constructors:
	CWizBitMatrix ()
		{
		Set(0);
		}
	CWizBitMatrix (const CWizBitMatrix& T)
		{
		Copy (T);
		}
// Destructor:
	~CWizBitMatrix () {}
public:
// Operators:
	CWizBitMatrix& operator=(const CWizBitMatrix& T)
		{
		Copy (T);
		return *this;
		}
	CWizBitVector<BIT_MATRIX_COLS> operator[](int i)
		{
		return CWizBitVector<BIT_MATRIX_COLS>(&m_Data[i][0]);
		}	
	const CWizConstBitVector<BIT_MATRIX_COLS> operator[](int i) const
		{
		return CWizConstBitVector<BIT_MATRIX_COLS>(&m_Data[i][0]);
		}	
	CWizBitMatrix& operator=(BOOL b)
		{
		Set (b);
		return *this;
		}
// Operations:
protected:
// Implementation:
	int  Bytes() const
		{
		return BIT_MATRIX_ROWS*WORDS_IN_LINE*sizeof(DWORD);
		}
	void Copy (const CWizBitMatrix& T)
		{
		memcpy (&m_Data[0][0], &(T.m_Data[0][0]), Bytes());
		}
	void Set (BOOL b)
		{
		char ch = (b) ? 0xFF : 0;
		memset (&m_Data[0][0], ch, Bytes());
		}
protected:
// Members:
	DWORD	m_Data [BIT_MATRIX_ROWS][WORDS_IN_LINE];
};

/////////////////////////////////////////////////////////////////////////////
#endif // __CWizBitMatrix_H


